﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Command
{
	/// <summary>
	/// The 'ConcreteCommand' class
	/// </summary>
	class CalculatorCommand : Command
	{
		private char _operator;
		private int _operand;
		private Calculator _calculator;

		// Constructor
		// @ makes possible the use of reserved word as variable names
		public CalculatorCommand(Calculator calculator,
			char @operator, int operand)
		{
			_calculator = calculator;
			_operator = @operator;
			_operand = operand;
		}

		// Gets operator
		public char Operator
		{
			set { _operator = value; }
		}

		// Get operand
		public int Operand
		{
			set { _operand = value; }
		}

		// Execute new command
		public override void Execute()
		{
			_calculator.Operation(_operator, _operand);
		}

		// Unexecute last command
		public override void UnExecute()
		{
			_calculator.Operation(Undo(_operator), _operand);
		}

		// Returns opposite operator for given operator
		private char Undo(char @operator)
		{
			switch (@operator)
			{
				case '+': return '-';
				case '-': return '+';
				case '*': return '/';
				case '/': return '*';
				default:
					throw new	ArgumentException("@operator");
			}
		}
	}
}
