﻿using System.Collections.Generic;
using System.Windows.Controls;

namespace CompositePatternHead.CompositeHead
{
    class Picture : CanvasComponent
    {
        private List<CanvasComponent> _children = new List<CanvasComponent>();

        public override void Add(CanvasComponent c)
        {
            c.ParentComponent = this;
            if (c is Picture)
            {
                c.MarginLeft = MarginLeft + c.MarginLeft;
                c.MarginTop = MarginTop + c.MarginTop;
            }

            _children.Add(c);
        }

        public override void Remove(CanvasComponent c)
        {
            _children.Remove(c);
        }

        public override Canvas DrawElements(Canvas theCanvas)
        {
            foreach (CanvasComponent aChild in _children)
            {
                theCanvas = aChild.DrawElements(theCanvas);
            }

            return theCanvas;
        }
    }
}
