﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace CompositePatternHead.CompositeHead
{
    class Rectangle : CanvasComponent
    {
        private System.Windows.Shapes.Rectangle rectangle;
        public int Width { get; set; }
        public int Height { get; set; }
        public Color FillColor { get; set; }
        public Color BorderColor { get; set; }

        public override Canvas DrawElements(Canvas theCanvas)
        {
            int parentMarginX = ParentComponent.MarginLeft;
            int parentMarginY = ParentComponent.MarginTop;

            rectangle = new System.Windows.Shapes.Rectangle()
            {
                Width = Width,
                Height = Height,
                Margin = new Thickness(left: MarginLeft + parentMarginX,
                                       top: MarginTop + parentMarginY,
                                       right: 0,
                                       bottom: 0),
                Fill = new SolidColorBrush(FillColor),
                Stroke = new SolidColorBrush(BorderColor)
            };

            theCanvas.Children.Add(rectangle);

            return theCanvas;
        }
    }
}
