﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace CompositePatternHead.CompositeHead
{
    class Triangle : CanvasComponent
    {
        private PointCollection points = new PointCollection();
        private Polygon triangle;
        public int Width { get; set; }
        public int Height { get; set; }
        public Color FillColor { get; set; }
        public Color BorderColor { get; set; }

        public Triangle(int width, int height)
        {
            Width = width;
            Height = height;
        }

        public override Canvas DrawElements(Canvas theCanvas)
        {
            int parentMarginX = ParentComponent.MarginLeft;
            int parentMarginY = ParentComponent.MarginTop;

            points.Add(new Point(0, 0));
            points.Add(new Point(Width, 0));
            points.Add(new Point(Width / 2, -Height));

            triangle = new Polygon()
            {
                Fill = new SolidColorBrush(FillColor),
                Stroke = new SolidColorBrush(BorderColor),
                HorizontalAlignment = HorizontalAlignment.Left,
                VerticalAlignment = VerticalAlignment.Center,
                StrokeThickness = 1,
                Margin = new Thickness(left: MarginLeft + parentMarginX,
                                       top: MarginTop + parentMarginY,
                                       right: 0,
                                       bottom: 0),
                Points = points
            };

            theCanvas.Children.Add(triangle);

            return theCanvas;
        }
    }
}
