﻿using CompositePatternHead.CompositeHead;
using System.Windows;
using System.Windows.Media;

namespace CompositePatternHead
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var earLeft = new Rectangle()
            {
                Width = 3,
                Height = 20,
                MarginLeft = 0,
                MarginTop = 30,
                FillColor = Colors.Blue
            };
            var earRight = new Rectangle()
            {
                Width = 3,
                Height = 20,
                MarginLeft = 103,
                MarginTop = 30,
                FillColor = Colors.Blue
            };
            var mouth = new Rectangle()
            {
                Width = 30,
                Height = 10,
                MarginLeft = 38,
                MarginTop = 85,
                BorderColor = Colors.Blue
            };
            var eyeLeft = new Triangle(10, 6)
            {
                BorderColor = Colors.Blue
            };
            var eyeRight = new Triangle(10, 6)
            {
                MarginLeft = 40,
                BorderColor = Colors.Blue
            };
            var nose = new Triangle(10, 6)
            {
                MarginLeft = 48,
                MarginTop = 65,
                BorderColor = Colors.Blue
            };
            var head = new Octagon(100, 100) {
                MarginLeft = 3,
                MarginTop = 0,
                BorderColor = Colors.Blue
            };

            Picture Head = new Picture()
            {
                MarginLeft = 1024 / 2 - 100,
                MarginTop = 600 / 2 - 100
            };

            Head.Add(head);

            Picture Ears = new Picture();
            Ears.Add(earLeft);
            Ears.Add(earRight);
            Head.Add(Ears);

            Picture Eyes = new Picture() {
                MarginLeft = 28,
                MarginTop = 35
            };
            Eyes.Add(eyeLeft);
            Eyes.Add(eyeRight);
            Head.Add(Eyes);

            Head.Add(nose);

            Picture Mouth = new Picture();
            Mouth.Add(mouth);
            Head.Add(Mouth);

            mainCanvas = Head.DrawElements(mainCanvas);
        }
    }
}
