﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IteratorPattern
{
	public class MyIterator:IMyIterator
	{
		private IMyList _list;
		private int _current;

		// Constructor
		public MyIterator(IMyList list)
		{
			_list = list;
		}
 
		/// <summary>
		/// Gets first item.
		/// </summary>
		/// <returns>First item of the list.</returns>
		public object First()
		{
			return _list[0];
		}
 
		/// <summary>
		/// Gets next item.
		/// </summary>
		/// <returns>Next item of the list.</returns>
		public object Next()
		{
			object ret = null;
			_current++;
			if (_current < _list.Count - 1)
			{
				ret = _list[_current];
			}
			return ret;
		}

		// Gets current iteration item
		public object CurrentItem()
		{
			return _list[_current];
		}

		// Gets whether iterations are complete
		public bool IsDone()
		{
			return _current >= _list.Count;
		}

		public void SetCurrent(int ItemNo)
		{
			_current=ItemNo;
		}
	}
}
