﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ACME_2000_car
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class AutoView : Window, IVehicleView
	{
		private IVehicleControl Control = new AutomobileControl();
		private IVehicleModel Model = new RaceCar("Speedy");
		public AutoView()
		{
			InitializeComponent();
			WireUp(Control, Model);
		}

		public void WireUp(IVehicleControl paramControl, IVehicleModel paramModel)
		{
			// If we're switching Models, don't keep watching
			// the old one! 
			if (Model != null)
			{
				Model.RemoveObserver(this);
			}
			Model = paramModel;
			Control = paramControl;
			Control.SetModel(Model);
			Control.SetView(this);
			Model.AddObserver(this);
		}

	

		private void btnAccelerate_OnClick(object sender, RoutedEventArgs e)
		{
			Control.RequestAccelerate(5);
		}
		private void btnDecelerate_OnClick(object sender, RoutedEventArgs e)
		{
			Control.RequestDecelerate(5);
		}
		private void btnTurnLeft_OnClick(object sender, RoutedEventArgs e)
		{
			Control.RequestTurn(RelativeDirection.Left);
		}
		private void btnTurnRight_OnClick(object sender, RoutedEventArgs e)
		{
			Control.RequestTurn(RelativeDirection.Right);
		}
		public void UpdateInterface(IVehicleModel auto)
		{
			tbDirection.Text = auto.Direction.ToString();
			tbSpeed.Text=	auto.Speed.ToString()+" mph";
		}
		public void DisableAcceleration()
		{
			btnAccelerate.IsEnabled = false;
		}
		public void EnableAcceleration()
		{
			this.btnAccelerate.IsEnabled = true;
		}
		public void DisableDeceleration()
		{
			btnDecelerate.IsEnabled = false;
		}
		public void EnableDeceleration()
		{
			btnDecelerate.IsEnabled = true;
		}
		public void DisableTurning()
		{
			btnTurnRight.IsEnabled = btnTurnLeft.IsEnabled = false;
		}
		public void EnableTurning()
		{
			btnTurnRight.IsEnabled = this.btnTurnLeft.IsEnabled = true;
		}
		public void Update(IVehicleModel paramModel)
		{
			UpdateInterface(paramModel);
		}
	}
}
