﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ACME_2000_car
{
	public class AutomobileControl : IVehicleControl
	{
		private IVehicleModel Model;
		private IVehicleView View;
		public AutomobileControl(IVehicleModel paramModel, IVehicleView paramView)
		{
			Model = paramModel;
			View = paramView;
		}
		public AutomobileControl()
		{
		}
		#region IVehicleControl Members
		public void SetModel(IVehicleModel paramModel)
		{
			Model = paramModel;
		}
		public void SetView(IVehicleView paramView)
		{
			View = paramView;
		}
		public void RequestAccelerate(int paramAmount)
		{
			if (Model == null) return;
			Model.Accelerate(paramAmount);
			if (View != null) SetView();
		}
		public void RequestDecelerate(int paramAmount)
		{
			if (Model == null) return;
			Model.Decelerate(paramAmount);
			if (View != null) SetView();
		}
		public void RequestTurn(RelativeDirection paramDirection)
		{
			if (Model == null) return;
			Model.Turn(paramDirection);
			if (View != null) SetView();
		}
		#endregion
		public void SetView()
		{
			if (Model.Speed >= Model.MaxSpeed)
			{
				View.DisableAcceleration();
				View.EnableDeceleration();
			}
			else if (Model.Speed <= Model.MaxReverseSpeed)
			{
				View.DisableDeceleration();
				View.EnableAcceleration();
			}
			else
			{
				View.EnableAcceleration();
				View.EnableDeceleration();
			}
			if (Model.Speed >= Model.MaxTurnSpeed)
			{
				View.DisableTurning();
			}
			else
			{
				View.EnableTurning();
			}
		}
	}
}
