﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ACME_2000_car
{
	public interface IVehicleControl
	{
		void RequestAccelerate(int paramAmount);
		void RequestDecelerate(int paramAmount);
		void RequestTurn(RelativeDirection paramDirection);
		void SetModel(IVehicleModel paramAuto); 
		void SetView(IVehicleView paramView);
	}

	public interface IVehicleModel
	{
		string Name { get; set; }
		int Speed { get; set; }
		int MaxSpeed { get; }
		int MaxTurnSpeed { get; }
		int MaxReverseSpeed { get; }
		AbsoluteDirection Direction { get; set; }
		void Turn(RelativeDirection paramDirection);
		void Accelerate(int paramAmount);
		void Decelerate(int paramAmount);
		void AddObserver(IVehicleView paramView); void RemoveObserver(IVehicleView paramView); void NotifyObservers();
	}

	public interface IVehicleView
	{
		void DisableAcceleration();
		void EnableAcceleration();
		void DisableDeceleration();
		void EnableDeceleration();
		void DisableTurning();
		void EnableTurning();
		void Update(IVehicleModel paramModel);
	}
}
