﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Worker;
using Moq;
namespace TestProject
{
    [TestClass]
    public class UserTest
    {
        [TestMethod]
        public void TestLoginFalse()
        {
            var a = new FakeAuthenticate();
            var u = new User { UserName="Bob", Password="1234"};
            u.LoginUser(a);
            Assert.AreEqual(false, u.IsAuthenticated);
        }

        [TestMethod]
        public void TestLoginTrue()
        {
            var u = new User { UserName = "Bob", Password = "1234" };
            var MockAuthenticate = new Mock<IAuthenticate>();
            MockAuthenticate.Setup(a => a.Validate(u.UserName, u.Password)).Returns(true);
            u.LoginUser(MockAuthenticate.Object);
            Assert.AreEqual(true, u.IsAuthenticated);
        }
    }
}
