using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.IO;

namespace Client
{
    class ActualPricesProxy : IActualPrices
    {
        public int GoldPrice
        {
            get
            {
                return GetResponseFromServer("g");
            }
        }

        public int SilverPrice
        {
            get
            {
                return GetResponseFromServer("s");
            }
        }

        public int DollarToForint
        {
            get
            {
                return GetResponseFromServer("d");
            }
        }

        private int GetResponseFromServer(string input)
        {
            int result = 0;
            using (TcpClient client = new TcpClient())
            {
                client.Connect("127.0.0.1", 9999);

                Stream stream = client.GetStream();
								// ASCII --> Unicode
                ASCIIEncoding asen = new ASCIIEncoding();
                byte[] ba = asen.GetBytes(input.ToCharArray());

                stream.Write(ba, 0, ba.Length);

                byte[] br = new byte[100];
                int k = stream.Read(br, 0, 100);
				  
                result += BitConverter.ToInt32(br,0);
                client.Close();
            }
            return result;
        }

    }
}
