﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using Szoveg.Annotations;

namespace Szoveg
{
	public class Model:IModel
	{
		/// <summary>
		/// A ViewModell objektum referenciáját tároló adattag.
		/// </summary>
		private IViewModel vm;
		public Model(IViewModel viewModel)
		{
			vm = viewModel;
		}
		/// <summary>
		/// Adattag, amiben nyilvántartjuk, hogy megváltozott-e a modellben tárolt adat 
		/// a legutóbbi mentés óta. Modell állapota.
		/// </summary>
		public bool VoltVáltozás { get; set; }
		
		/// <summary>
		/// A modellben az adattárolásra szolgáló adattag.
		/// </summary>
		private string szöveg;

		/// <summary>
		/// A modellben tárolt adat elérését és módosítását lehetővé tevő tulajdonság.
		/// </summary>
		public string Szöveg
		{
			get { return szöveg; }
			set 
			{ 
				szöveg = value;
				VoltVáltozás = true;
			}
		}
		

		
	}
}
