﻿using System.IO;

namespace Szoveg
{
	public class Model:IModel
	{
		private IViewModel vm;
		public Model(IViewModel viewModel)
		{
			vm = viewModel;
		}
		/// <summary>
		/// Adattag, amiben nyilvántartjuk, hogy megváltozott-e a szerkesztőmező 
		/// tartalma a legutóbbi mentés óta.
		/// </summary>
		public bool VoltVáltozás { get; set; }
		/// <summary>
		/// Állománynév tárolására szolgáló adattag.
		/// </summary>
		string ÁllományNév = "valami.txt";
		private string _Szöveg;

		/// <summary>
		/// Gondoskodik a szövegmező tartalmának lementéséről
		/// </summary>
		public string Szöveg
		{
			get { return _Szöveg; }
			set 
			{ 
				_Szöveg = value;
				VoltVáltozás = true;
			}
		}
		public void Mentés()
		{
			// Mentést végző objektum létrehozása, használata, lezárása
			using (var sw = new StreamWriter(ÁllományNév))
			{
				// Szövegmező tartalmának mentése
				sw.Write(Szöveg);
			}
			VoltVáltozás = false;
		}

		public void Betöltés()
		{
			// Beolvasást végző objektum létrehozása
			var sr = new StreamReader(ÁllományNév);
			// Az állomány teljes tartalmának beolvasása
			vm.Szöveg= sr.ReadToEnd();
			// Állomány lezárása
			sr.Close();
			VoltVáltozás = false;
		}
	}
}
